<?php

    include "koneksi.php";

    $tanggal_sekarang = date("dmy");
    $bln_sekarang = date("m");

    // Per Tanggal Hari ini
    // $query = "SELECT COUNT(*) AS jumlah FROM transaksi WHERE kd_transaksi LIKE 'INV".$tanggal_sekarang."%'";
    // $result = mysqli_query($conn, $query);
    // $row = mysqli_fetch_assoc($result);
    // $nomor_urut = str_pad($row['jumlah']+1, 3, '0', STR_PAD_LEFT);

    // $id_unik = "INV".$tanggal_sekarang.$nomor_urut;

    // Mengambil nomor urut per bulan
    $query = "SELECT COUNT(*) AS jumlah FROM transaksi WHERE SUBSTR(kd_transaksi, 6, 2) = '{$bln_sekarang}'";
    $result = mysqli_query($conn, $query);
    $row = mysqli_fetch_assoc($result);
    $nomor_urut = sprintf("%03d", $row['jumlah'] + 1);

    // Membuat id unik
    $id_unik = "INV{$tanggal_sekarang}{$nomor_urut}";

    date_default_timezone_set('Asia/Jakarta');
    $timestamp = time();
    $date = date("Y-m-d H:i:s", $timestamp);
    $kd_transaksi       = $id_unik;
    $id_customer        = $_POST['id_customer'];
    $jum_pembelian      = $_POST['jum_pembelian'];
    $tot_pembelian      = $_POST['tot_pembelian'];
    $diskon             = $_POST['diskon'];
    $estimasi_waktu     = $_POST['estimasi_waktu'];
    $mode_bayar         = $_POST['mode_bayar'];
    $mode_pengambilan   = $_POST['mode_pengambilan'];
    $notes              = $_POST['notes'];
    $total_bayar        = $_POST['total_bayar'];
    $status_bayar       = $_POST['status_bayar'];
    $status_order       = $_POST['status_order'];
    $itemKd             = $_POST['itemKd'];
    $itemJum            = $_POST['itemJum'];
    $itemHarga          = $_POST['itemHarga'];
    $petugas            = $_POST['petugas'];

    $est_tanggal = new DateTime('today');
    $est_tanggal->add(new DateInterval('P' . $estimasi_waktu . 'D'));
    $tgl_selesai = $estimasi_waktu." Hari, ".$est_tanggal->format('Y-m-d');

    $myArray = explode(",", $itemKd);
    $myArray2 = explode(",", $itemJum);
    $myHarga = explode(",", $itemHarga);

    mysqli_autocommit($conn, FALSE);
    mysqli_begin_transaction($conn);

    try {
        $query = "INSERT INTO transaksi VALUES 
            ('$kd_transaksi','$id_customer','$jum_pembelian','$tot_pembelian','$diskon','$tgl_selesai','$mode_bayar','$mode_pengambilan',
            '$notes','$total_bayar','$status_bayar', '$status_order', '$date', NULL, '$petugas')
        ";
        mysqli_query($conn, $query);

        for ($i = 0; $i < count($myArray); $i++) {
            $value1 = $myArray[$i];
            $value2 = $myArray2[$i];
            $valueHarga = $myHarga[$i];

            $query2 = "INSERT INTO detail_transaksi VALUES ('', '$kd_transaksi', '$value1', '$valueHarga', '$value2')";
            mysqli_query($conn, $query2);
        }

        //commit transaksi
        mysqli_commit($conn);
        $response["success"] = "1";
        $response["message"] = "Data sukses diinput";
        echo json_encode($response);

    } catch (Exception $e) {
        //rollback transaksi jika terjadi error
        mysqli_rollback($conn);
        
        $response["success"] = "0";
        $response["message"] = "Maaf , terjadi kesalahan" . $e->getMessage();
        echo json_encode($response);
    }

    mysqli_close($conn);

    // $query = "INSERT INTO transaksi VALUES 
    // ('$kd_transaksi','$id_customer','$jum_pembelian','$tot_pembelian','$diskon','$tgl_selesai','$mode_bayar','$mode_pengambilan',
    // '$notes','$total_bayar','$status_bayar', '$status_order', '$date', NULL, '$petugas')";
    
    // $hasil = mysqli_query($conn, $query);
    // if($hasil){

    //     for ($i = 0; $i < count($myArray); $i++) {
    //         $value1 = $myArray[$i];
    //         $value2 = $myArray2[$i];
    //         $valueHarga = $myHarga[$i];
        
    //         $query2 = "INSERT INTO detail_transaksi VALUES ('', '$kd_transaksi', '$value1', '$valueHarga', '$value2')";
    //         $hasil2 = mysqli_query($conn, $query2);
    //     }

    //     // $query2 = "INSERT INTO detail_transaksi VALUES ('', '$kd_transaksi','" . implode("'), ('", $myArray) . "','" . implode("'), ('", $myArray2) . "')";
    //     // $hasil2 = mysqli_query($conn, $query2);
    //     if($hasil2){
    //         $response["success"] = "1";
    //         $response["message"] = "Data sukses diinput";
    //         echo json_encode($response);
    //     } else {
    //         $response["success"] = "0";
    //         $response["message"] = "Maaf , terjadi kesalahan";
    //         echo json_encode($response);
    //     }
    // } else {
    //     $response["success"] = "0";
    //     $response["message"] = "Maaf , terjadi kesalahan";
    //     echo json_encode($response);
    // }
?>